;---------------------------------------------
; Get Metadata Demo
; Copyright (C) by ManHunter / PCL
; https://www.manhunter.ru
;---------------------------------------------

format PE GUI 4.0
entry start

include 'win32w.inc'

;---------------------------------------------

section '.data' data readable writeable

struct PROPVARIANT
    vt        dw ?
    wReserved rw 3
    struct
        cbSize    dd ?
        pBlobData dd ?
    ends
ends

struct PROPKEY
     fmtid rb 16
     pid   dd ?
ends

GPS_READWRITE = 2

; GUID {886D8EEB-8CF2-4446-8D02-CDBA1DBDCF99}
IID_IPropertyStore dd 0886D8EEBh
                   dw 08CF2h
                   dw 04446h
                   db 08Dh, 002h, 0CDh, 0BAh, 01Dh, 0BDh, 0CFh, 099h

; IID_IPropertyStore Interface
struct IPropertyStore
    ; IUnknown
    QueryInterface dd ?   ; 000h
    AddRef         dd ?   ; 004h
    Release        dd ?   ; 008h
    ; IPropertyStore
    GetCount       dd ?   ; 00Ch
    GetAt          dd ?   ; 010h
    GetValue       dd ?   ; 014h
    SetValue       dd ?   ; 018h
    Commit         dd ?   ; 01Ch
ends

; GUID {F29F85E0-4FF9-1068-AB91-08002B27B3D9}
PKEY_Title dd 0F29F85E0h
           dw 04FF9h
           dw 01068h
           db 0ABh, 091h, 008h, 000h, 02Bh, 027h, 0B3h, 0D9h
PKEY_Title_pid = 2

; GUID {56A3372E-CE9C-11D2-9F0E-006097C686F6}
PKEY_Music_AlbumTitle dd 056A3372Eh
                      dw 0CE9Ch
                      dw 011D2h
                      db 09Fh, 00Eh, 000h, 060h, 097h, 0C6h, 086h, 0F6h
PKEY_Music_AlbumTitle_pid = 4

; GUID {56A3372E-CE9C-11D2-9F0E-006097C686F6}
PKEY_Music_Artist dd 056A3372Eh
                  dw 0CE9Ch
                  dw 011D2h
                  db 09Fh, 00Eh, 000h, 060h, 097h, 0C6h, 086h, 0F6h
PKEY_Music_Artist_pid = 2

; GUID {64440490-4C8B-11D1-8B70-080036B11A03}
PKEY_Media_Duration dd 064440490h
                    dw 04C8Bh
                    dw 011D1h
                    db 08Bh, 070h, 008h, 000h, 036h, 0B1h, 01Ah, 003h
PKEY_Media_Duration_pid = 3

pStore  dd ?

artist  rw 100h
album   rw 100h
title   rw 100h
durat   dd ?

buff    rw 800h

szTitle du 'Metadata',0
mask    du 'Artist: %s',13,10,'Album: %s',13,10,'Title: %s',13,10,'Duration: %i sec',0

sample  du 'sample.mp3',0
fname   rw MAX_PATH

prop    PROPKEY
variant PROPVARIANT

;---------------------------------------------

section '.code' code readable executable

  start:
        invoke  CoInitialize,0

        ;     
        invoke  GetFullPathName,sample,MAX_PATH,fname,NULL
        invoke  SHGetPropertyStoreFromParsingName,fname,\
                NULL,GPS_READWRITE,IID_IPropertyStore,pStore
        or      eax,eax
        jnz     loc_ret

        ; 
        mov     edi,prop.fmtid
        mov     esi,PKEY_Music_Artist
        movsd
        movsd
        movsd
        movsd
        mov     [prop.pid],PKEY_Music_Artist_pid

        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.GetValue],[pStore],prop,variant

        cmp     [variant.cbSize],0
        je      @f
        mov     eax,[variant.pBlobData]
        mov     eax,[eax]
        invoke  lstrcpy,artist,eax
@@:
        ;  
        mov     edi,prop.fmtid
        mov     esi,PKEY_Music_AlbumTitle
        movsd
        movsd
        movsd
        movsd
        mov     [prop.pid],PKEY_Music_AlbumTitle_pid

        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.GetValue],[pStore],prop,variant

        cmp     [variant.cbSize],0
        je      @f
        invoke  lstrcpy,album,[variant.cbSize]
@@:
        ;  
        mov     edi,prop.fmtid
        mov     esi,PKEY_Title
        movsd
        movsd
        movsd
        movsd
        mov     [prop.pid],PKEY_Title_pid

        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.GetValue],[pStore],prop,variant

        cmp     [variant.cbSize],0
        je      @f
        invoke  lstrcpy,title,[variant.cbSize]
@@:
        ; 
        mov     edi,prop.fmtid
        mov     esi,PKEY_Media_Duration
        movsd
        movsd
        movsd
        movsd
        mov     [prop.pid],PKEY_Media_Duration_pid

        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.GetValue],[pStore],prop,variant

        mov     eax,[variant.cbSize]
        xor     edx,edx
        mov     ecx,10000000
        div     ecx
        mov     [durat],eax

        ;   
        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.Release],[pStore]

        invoke  wsprintf,buff,mask,artist,album,title,[durat]
        add     esp,24
        invoke  MessageBox,0,buff,szTitle,0

loc_ret:
        invoke  CoUninitialize

        invoke  ExitProcess,0

;---------------------------------------------

section '.idata' import data readable writeable

  library kernel32,'kernel32.dll',\
          user32,'user32.dll',\
          shell32,'shell32.dll',\
          shell33,'shell32.dll',\
          ole32,'ole32.dll'

  include 'apiw\kernel32.inc'
  include 'apiw\user32.inc'
  include 'apiw\shell32.inc'

import shell33,\
      SHGetPropertyStoreFromParsingName,'SHGetPropertyStoreFromParsingName'

import ole32,\
      CoInitialize,'CoInitialize',\
      CoUninitialize,'CoUninitialize'
