;---------------------------------------------
; Set Metadata Demo
; Copyright (C) by ManHunter / PCL
; https://www.manhunter.ru
;---------------------------------------------

format PE GUI 4.0
entry start

include 'win32w.inc'

;---------------------------------------------

section '.data' data readable writeable

struct PROPVARIANT
    vt        dw ?
    wReserved rw 3
    struct
        cbSize    dd ?
        pBlobData dd ?
    ends
ends

struct PROPKEY
     fmtid rb 16
     pid   dd ?
ends

GPS_READWRITE = 2
VT_BSTR       = 8

; GUID {886D8EEB-8CF2-4446-8D02-CDBA1DBDCF99}
IID_IPropertyStore dd 0886D8EEBh
                   dw 08CF2h
                   dw 04446h
                   db 08Dh, 002h, 0CDh, 0BAh, 01Dh, 0BDh, 0CFh, 099h

; IID_IPropertyStore Interface
struct IPropertyStore
    ; IUnknown
    QueryInterface dd ?   ; 000h
    AddRef         dd ?   ; 004h
    Release        dd ?   ; 008h
    ; IPropertyStore
    GetCount       dd ?   ; 00Ch
    GetAt          dd ?   ; 010h
    GetValue       dd ?   ; 014h
    SetValue       dd ?   ; 018h
    Commit         dd ?   ; 01Ch
ends

; GUID {56A3372E-CE9C-11D2-9F0E-006097C686F6}
PKEY_Music_AlbumTitle dd 056A3372Eh
                      dw 0CE9Ch
                      dw 011D2h
                      db 09Fh, 00Eh, 000h, 060h, 097h, 0C6h, 086h, 0F6h
PKEY_Music_AlbumTitle_pid = 4

pStore  dd ?

szNew   du 'THINGS OF BEAUTY <-- NEW!!!',0

sample  du 'sample.mp3',0
fname   rw MAX_PATH
bname   rw MAX_PATH
bext    du '.bak',0

prop    PROPKEY
variant PROPVARIANT

;---------------------------------------------

section '.code' code readable executable

  start:
        invoke  CoInitialize,0

        ;     
        invoke  GetFullPathName,sample,MAX_PATH,fname,NULL

        ;   
        invoke  lstrcpy,bname,fname
        invoke  lstrcat,bname,bext
        invoke  CopyFile,fname,bname,TRUE

        invoke  SHGetPropertyStoreFromParsingName,fname,\
                NULL,GPS_READWRITE,IID_IPropertyStore,pStore
        or      eax,eax
        jnz     loc_ret

        ;  
        mov     edi,prop.fmtid
        mov     esi,PKEY_Music_AlbumTitle
        movsd
        movsd
        movsd
        movsd
        mov     [prop.pid],PKEY_Music_AlbumTitle_pid

        ;     
        mov     [variant.vt],VT_BSTR
        mov     [variant.cbSize],szNew
        mov     [variant.pBlobData],0

        ;    
        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.SetValue],[pStore],prop,variant

        ;  
        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.Commit],[pStore]

        ;   
        mov     eax,[pStore]
        mov     eax,[eax]
        stdcall [eax+IPropertyStore.Release],[pStore]

loc_ret:
        invoke  CoUninitialize

        invoke  ExitProcess,0

;---------------------------------------------

section '.idata' import data readable writeable

  library kernel32,'kernel32.dll',\
          user32,'user32.dll',\
          shell32,'shell32.dll',\
          shell33,'shell32.dll',\
          ole32,'ole32.dll'

  include 'apiw\kernel32.inc'
  include 'apiw\user32.inc'
  include 'apiw\shell32.inc'

import shell33,\
      SHGetPropertyStoreFromParsingName,'SHGetPropertyStoreFromParsingName'

import ole32,\
      CoInitialize,'CoInitialize',\
      CoUninitialize,'CoUninitialize'
